"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const AuthorizeDBSecurityGroupIngress_1 = require("../model/operations/AuthorizeDBSecurityGroupIngress");
class AuthorizeDBSecurityGroupIngressCommand {
    constructor(input) {
        this.input = input;
        this.model = AuthorizeDBSecurityGroupIngress_1.AuthorizeDBSecurityGroupIngress;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.AuthorizeDBSecurityGroupIngressCommand = AuthorizeDBSecurityGroupIngressCommand;
//# sourceMappingURL=AuthorizeDBSecurityGroupIngressCommand.js.map