"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const DeleteDBClusterParameterGroup_1 = require("../model/operations/DeleteDBClusterParameterGroup");
class DeleteDBClusterParameterGroupCommand {
    constructor(input) {
        this.input = input;
        this.model = DeleteDBClusterParameterGroup_1.DeleteDBClusterParameterGroup;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.DeleteDBClusterParameterGroupCommand = DeleteDBClusterParameterGroupCommand;
//# sourceMappingURL=DeleteDBClusterParameterGroupCommand.js.map