"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const DeleteDBInstance_1 = require("../model/operations/DeleteDBInstance");
class DeleteDBInstanceCommand {
    constructor(input) {
        this.input = input;
        this.model = DeleteDBInstance_1.DeleteDBInstance;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.DeleteDBInstanceCommand = DeleteDBInstanceCommand;
//# sourceMappingURL=DeleteDBInstanceCommand.js.map