"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const DeleteOptionGroup_1 = require("../model/operations/DeleteOptionGroup");
class DeleteOptionGroupCommand {
    constructor(input) {
        this.input = input;
        this.model = DeleteOptionGroup_1.DeleteOptionGroup;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.DeleteOptionGroupCommand = DeleteOptionGroupCommand;
//# sourceMappingURL=DeleteOptionGroupCommand.js.map