"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const DescribeOrderableDBInstanceOptions_1 = require("../model/operations/DescribeOrderableDBInstanceOptions");
class DescribeOrderableDBInstanceOptionsCommand {
    constructor(input) {
        this.input = input;
        this.model = DescribeOrderableDBInstanceOptions_1.DescribeOrderableDBInstanceOptions;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.DescribeOrderableDBInstanceOptionsCommand = DescribeOrderableDBInstanceOptionsCommand;
//# sourceMappingURL=DescribeOrderableDBInstanceOptionsCommand.js.map