"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const ModifyCurrentDBClusterCapacity_1 = require("../model/operations/ModifyCurrentDBClusterCapacity");
class ModifyCurrentDBClusterCapacityCommand {
    constructor(input) {
        this.input = input;
        this.model = ModifyCurrentDBClusterCapacity_1.ModifyCurrentDBClusterCapacity;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.ModifyCurrentDBClusterCapacityCommand = ModifyCurrentDBClusterCapacityCommand;
//# sourceMappingURL=ModifyCurrentDBClusterCapacityCommand.js.map