"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const ModifyDBParameterGroup_1 = require("../model/operations/ModifyDBParameterGroup");
class ModifyDBParameterGroupCommand {
    constructor(input) {
        this.input = input;
        this.model = ModifyDBParameterGroup_1.ModifyDBParameterGroup;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.ModifyDBParameterGroupCommand = ModifyDBParameterGroupCommand;
//# sourceMappingURL=ModifyDBParameterGroupCommand.js.map