"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const ModifyDBSubnetGroup_1 = require("../model/operations/ModifyDBSubnetGroup");
class ModifyDBSubnetGroupCommand {
    constructor(input) {
        this.input = input;
        this.model = ModifyDBSubnetGroup_1.ModifyDBSubnetGroup;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.ModifyDBSubnetGroupCommand = ModifyDBSubnetGroupCommand;
//# sourceMappingURL=ModifyDBSubnetGroupCommand.js.map