"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const ModifyGlobalCluster_1 = require("../model/operations/ModifyGlobalCluster");
class ModifyGlobalClusterCommand {
    constructor(input) {
        this.input = input;
        this.model = ModifyGlobalCluster_1.ModifyGlobalCluster;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.ModifyGlobalClusterCommand = ModifyGlobalClusterCommand;
//# sourceMappingURL=ModifyGlobalClusterCommand.js.map