"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const PromoteReadReplicaDBCluster_1 = require("../model/operations/PromoteReadReplicaDBCluster");
class PromoteReadReplicaDBClusterCommand {
    constructor(input) {
        this.input = input;
        this.model = PromoteReadReplicaDBCluster_1.PromoteReadReplicaDBCluster;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.PromoteReadReplicaDBClusterCommand = PromoteReadReplicaDBClusterCommand;
//# sourceMappingURL=PromoteReadReplicaDBClusterCommand.js.map