"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const PurchaseReservedDBInstancesOffering_1 = require("../model/operations/PurchaseReservedDBInstancesOffering");
class PurchaseReservedDBInstancesOfferingCommand {
    constructor(input) {
        this.input = input;
        this.model = PurchaseReservedDBInstancesOffering_1.PurchaseReservedDBInstancesOffering;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.PurchaseReservedDBInstancesOfferingCommand = PurchaseReservedDBInstancesOfferingCommand;
//# sourceMappingURL=PurchaseReservedDBInstancesOfferingCommand.js.map