"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const RemoveFromGlobalCluster_1 = require("../model/operations/RemoveFromGlobalCluster");
class RemoveFromGlobalClusterCommand {
    constructor(input) {
        this.input = input;
        this.model = RemoveFromGlobalCluster_1.RemoveFromGlobalCluster;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.RemoveFromGlobalClusterCommand = RemoveFromGlobalClusterCommand;
//# sourceMappingURL=RemoveFromGlobalClusterCommand.js.map