"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const RemoveRoleFromDBInstance_1 = require("../model/operations/RemoveRoleFromDBInstance");
class RemoveRoleFromDBInstanceCommand {
    constructor(input) {
        this.input = input;
        this.model = RemoveRoleFromDBInstance_1.RemoveRoleFromDBInstance;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.RemoveRoleFromDBInstanceCommand = RemoveRoleFromDBInstanceCommand;
//# sourceMappingURL=RemoveRoleFromDBInstanceCommand.js.map