"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const StartActivityStream_1 = require("../model/operations/StartActivityStream");
class StartActivityStreamCommand {
    constructor(input) {
        this.input = input;
        this.model = StartActivityStream_1.StartActivityStream;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.StartActivityStreamCommand = StartActivityStreamCommand;
//# sourceMappingURL=StartActivityStreamCommand.js.map