"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const StopActivityStream_1 = require("../model/operations/StopActivityStream");
class StopActivityStreamCommand {
    constructor(input) {
        this.input = input;
        this.model = StopActivityStream_1.StopActivityStream;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.StopActivityStreamCommand = StopActivityStreamCommand;
//# sourceMappingURL=StopActivityStreamCommand.js.map