"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
const StopDBInstance_1 = require("../model/operations/StopDBInstance");
class StopDBInstanceCommand {
    constructor(input) {
        this.input = input;
        this.model = StopDBInstance_1.StopDBInstance;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    resolveMiddleware(clientStack, configuration) {
        const { handler } = configuration;
        const stack = clientStack.concat(this.middlewareStack);
        const handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    }
}
exports.StopDBInstanceCommand = StopDBInstanceCommand;
//# sourceMappingURL=StopDBInstanceCommand.js.map