"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AuthorizeDBSecurityGroupIngressInput_1 = require("../shapes/AuthorizeDBSecurityGroupIngressInput");
const AuthorizeDBSecurityGroupIngressOutput_1 = require("../shapes/AuthorizeDBSecurityGroupIngressOutput");
const DBSecurityGroupNotFoundFault_1 = require("../shapes/DBSecurityGroupNotFoundFault");
const InvalidDBSecurityGroupStateFault_1 = require("../shapes/InvalidDBSecurityGroupStateFault");
const AuthorizationAlreadyExistsFault_1 = require("../shapes/AuthorizationAlreadyExistsFault");
const AuthorizationQuotaExceededFault_1 = require("../shapes/AuthorizationQuotaExceededFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.AuthorizeDBSecurityGroupIngress = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "AuthorizeDBSecurityGroupIngress",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: AuthorizeDBSecurityGroupIngressInput_1.AuthorizeDBSecurityGroupIngressInput
    },
    output: {
        shape: AuthorizeDBSecurityGroupIngressOutput_1.AuthorizeDBSecurityGroupIngressOutput,
        resultWrapper: "AuthorizeDBSecurityGroupIngressResult"
    },
    errors: [
        {
            shape: DBSecurityGroupNotFoundFault_1.DBSecurityGroupNotFoundFault
        },
        {
            shape: InvalidDBSecurityGroupStateFault_1.InvalidDBSecurityGroupStateFault
        },
        {
            shape: AuthorizationAlreadyExistsFault_1.AuthorizationAlreadyExistsFault
        },
        {
            shape: AuthorizationQuotaExceededFault_1.AuthorizationQuotaExceededFault
        }
    ]
};
//# sourceMappingURL=AuthorizeDBSecurityGroupIngress.js.map