"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BacktrackDBClusterInput_1 = require("../shapes/BacktrackDBClusterInput");
const BacktrackDBClusterOutput_1 = require("../shapes/BacktrackDBClusterOutput");
const DBClusterNotFoundFault_1 = require("../shapes/DBClusterNotFoundFault");
const InvalidDBClusterStateFault_1 = require("../shapes/InvalidDBClusterStateFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.BacktrackDBCluster = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "BacktrackDBCluster",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: BacktrackDBClusterInput_1.BacktrackDBClusterInput
    },
    output: {
        shape: BacktrackDBClusterOutput_1.BacktrackDBClusterOutput,
        resultWrapper: "BacktrackDBClusterResult"
    },
    errors: [
        {
            shape: DBClusterNotFoundFault_1.DBClusterNotFoundFault
        },
        {
            shape: InvalidDBClusterStateFault_1.InvalidDBClusterStateFault
        }
    ]
};
//# sourceMappingURL=BacktrackDBCluster.js.map