"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CopyDBParameterGroupInput_1 = require("../shapes/CopyDBParameterGroupInput");
const CopyDBParameterGroupOutput_1 = require("../shapes/CopyDBParameterGroupOutput");
const DBParameterGroupNotFoundFault_1 = require("../shapes/DBParameterGroupNotFoundFault");
const DBParameterGroupAlreadyExistsFault_1 = require("../shapes/DBParameterGroupAlreadyExistsFault");
const DBParameterGroupQuotaExceededFault_1 = require("../shapes/DBParameterGroupQuotaExceededFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.CopyDBParameterGroup = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CopyDBParameterGroup",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CopyDBParameterGroupInput_1.CopyDBParameterGroupInput
    },
    output: {
        shape: CopyDBParameterGroupOutput_1.CopyDBParameterGroupOutput,
        resultWrapper: "CopyDBParameterGroupResult"
    },
    errors: [
        {
            shape: DBParameterGroupNotFoundFault_1.DBParameterGroupNotFoundFault
        },
        {
            shape: DBParameterGroupAlreadyExistsFault_1.DBParameterGroupAlreadyExistsFault
        },
        {
            shape: DBParameterGroupQuotaExceededFault_1.DBParameterGroupQuotaExceededFault
        }
    ]
};
//# sourceMappingURL=CopyDBParameterGroup.js.map