"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CopyDBSnapshotInput_1 = require("../shapes/CopyDBSnapshotInput");
const CopyDBSnapshotOutput_1 = require("../shapes/CopyDBSnapshotOutput");
const DBSnapshotAlreadyExistsFault_1 = require("../shapes/DBSnapshotAlreadyExistsFault");
const DBSnapshotNotFoundFault_1 = require("../shapes/DBSnapshotNotFoundFault");
const InvalidDBSnapshotStateFault_1 = require("../shapes/InvalidDBSnapshotStateFault");
const SnapshotQuotaExceededFault_1 = require("../shapes/SnapshotQuotaExceededFault");
const KMSKeyNotAccessibleFault_1 = require("../shapes/KMSKeyNotAccessibleFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.CopyDBSnapshot = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CopyDBSnapshot",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CopyDBSnapshotInput_1.CopyDBSnapshotInput
    },
    output: {
        shape: CopyDBSnapshotOutput_1.CopyDBSnapshotOutput,
        resultWrapper: "CopyDBSnapshotResult"
    },
    errors: [
        {
            shape: DBSnapshotAlreadyExistsFault_1.DBSnapshotAlreadyExistsFault
        },
        {
            shape: DBSnapshotNotFoundFault_1.DBSnapshotNotFoundFault
        },
        {
            shape: InvalidDBSnapshotStateFault_1.InvalidDBSnapshotStateFault
        },
        {
            shape: SnapshotQuotaExceededFault_1.SnapshotQuotaExceededFault
        },
        {
            shape: KMSKeyNotAccessibleFault_1.KMSKeyNotAccessibleFault
        }
    ]
};
//# sourceMappingURL=CopyDBSnapshot.js.map