"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CreateDBClusterSnapshotInput_1 = require("../shapes/CreateDBClusterSnapshotInput");
const CreateDBClusterSnapshotOutput_1 = require("../shapes/CreateDBClusterSnapshotOutput");
const DBClusterSnapshotAlreadyExistsFault_1 = require("../shapes/DBClusterSnapshotAlreadyExistsFault");
const InvalidDBClusterStateFault_1 = require("../shapes/InvalidDBClusterStateFault");
const DBClusterNotFoundFault_1 = require("../shapes/DBClusterNotFoundFault");
const SnapshotQuotaExceededFault_1 = require("../shapes/SnapshotQuotaExceededFault");
const InvalidDBClusterSnapshotStateFault_1 = require("../shapes/InvalidDBClusterSnapshotStateFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateDBClusterSnapshot = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateDBClusterSnapshot",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateDBClusterSnapshotInput_1.CreateDBClusterSnapshotInput
    },
    output: {
        shape: CreateDBClusterSnapshotOutput_1.CreateDBClusterSnapshotOutput,
        resultWrapper: "CreateDBClusterSnapshotResult"
    },
    errors: [
        {
            shape: DBClusterSnapshotAlreadyExistsFault_1.DBClusterSnapshotAlreadyExistsFault
        },
        {
            shape: InvalidDBClusterStateFault_1.InvalidDBClusterStateFault
        },
        {
            shape: DBClusterNotFoundFault_1.DBClusterNotFoundFault
        },
        {
            shape: SnapshotQuotaExceededFault_1.SnapshotQuotaExceededFault
        },
        {
            shape: InvalidDBClusterSnapshotStateFault_1.InvalidDBClusterSnapshotStateFault
        }
    ]
};
//# sourceMappingURL=CreateDBClusterSnapshot.js.map