"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CreateDBInstanceInput_1 = require("../shapes/CreateDBInstanceInput");
const CreateDBInstanceOutput_1 = require("../shapes/CreateDBInstanceOutput");
const DBInstanceAlreadyExistsFault_1 = require("../shapes/DBInstanceAlreadyExistsFault");
const InsufficientDBInstanceCapacityFault_1 = require("../shapes/InsufficientDBInstanceCapacityFault");
const DBParameterGroupNotFoundFault_1 = require("../shapes/DBParameterGroupNotFoundFault");
const DBSecurityGroupNotFoundFault_1 = require("../shapes/DBSecurityGroupNotFoundFault");
const InstanceQuotaExceededFault_1 = require("../shapes/InstanceQuotaExceededFault");
const StorageQuotaExceededFault_1 = require("../shapes/StorageQuotaExceededFault");
const DBSubnetGroupNotFoundFault_1 = require("../shapes/DBSubnetGroupNotFoundFault");
const DBSubnetGroupDoesNotCoverEnoughAZs_1 = require("../shapes/DBSubnetGroupDoesNotCoverEnoughAZs");
const InvalidDBClusterStateFault_1 = require("../shapes/InvalidDBClusterStateFault");
const InvalidSubnet_1 = require("../shapes/InvalidSubnet");
const InvalidVPCNetworkStateFault_1 = require("../shapes/InvalidVPCNetworkStateFault");
const ProvisionedIopsNotAvailableInAZFault_1 = require("../shapes/ProvisionedIopsNotAvailableInAZFault");
const OptionGroupNotFoundFault_1 = require("../shapes/OptionGroupNotFoundFault");
const DBClusterNotFoundFault_1 = require("../shapes/DBClusterNotFoundFault");
const StorageTypeNotSupportedFault_1 = require("../shapes/StorageTypeNotSupportedFault");
const AuthorizationNotFoundFault_1 = require("../shapes/AuthorizationNotFoundFault");
const KMSKeyNotAccessibleFault_1 = require("../shapes/KMSKeyNotAccessibleFault");
const DomainNotFoundFault_1 = require("../shapes/DomainNotFoundFault");
const BackupPolicyNotFoundFault_1 = require("../shapes/BackupPolicyNotFoundFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateDBInstance = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateDBInstance",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateDBInstanceInput_1.CreateDBInstanceInput
    },
    output: {
        shape: CreateDBInstanceOutput_1.CreateDBInstanceOutput,
        resultWrapper: "CreateDBInstanceResult"
    },
    errors: [
        {
            shape: DBInstanceAlreadyExistsFault_1.DBInstanceAlreadyExistsFault
        },
        {
            shape: InsufficientDBInstanceCapacityFault_1.InsufficientDBInstanceCapacityFault
        },
        {
            shape: DBParameterGroupNotFoundFault_1.DBParameterGroupNotFoundFault
        },
        {
            shape: DBSecurityGroupNotFoundFault_1.DBSecurityGroupNotFoundFault
        },
        {
            shape: InstanceQuotaExceededFault_1.InstanceQuotaExceededFault
        },
        {
            shape: StorageQuotaExceededFault_1.StorageQuotaExceededFault
        },
        {
            shape: DBSubnetGroupNotFoundFault_1.DBSubnetGroupNotFoundFault
        },
        {
            shape: DBSubnetGroupDoesNotCoverEnoughAZs_1.DBSubnetGroupDoesNotCoverEnoughAZs
        },
        {
            shape: InvalidDBClusterStateFault_1.InvalidDBClusterStateFault
        },
        {
            shape: InvalidSubnet_1.InvalidSubnet
        },
        {
            shape: InvalidVPCNetworkStateFault_1.InvalidVPCNetworkStateFault
        },
        {
            shape: ProvisionedIopsNotAvailableInAZFault_1.ProvisionedIopsNotAvailableInAZFault
        },
        {
            shape: OptionGroupNotFoundFault_1.OptionGroupNotFoundFault
        },
        {
            shape: DBClusterNotFoundFault_1.DBClusterNotFoundFault
        },
        {
            shape: StorageTypeNotSupportedFault_1.StorageTypeNotSupportedFault
        },
        {
            shape: AuthorizationNotFoundFault_1.AuthorizationNotFoundFault
        },
        {
            shape: KMSKeyNotAccessibleFault_1.KMSKeyNotAccessibleFault
        },
        {
            shape: DomainNotFoundFault_1.DomainNotFoundFault
        },
        {
            shape: BackupPolicyNotFoundFault_1.BackupPolicyNotFoundFault
        }
    ]
};
//# sourceMappingURL=CreateDBInstance.js.map