"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CreateEventSubscriptionInput_1 = require("../shapes/CreateEventSubscriptionInput");
const CreateEventSubscriptionOutput_1 = require("../shapes/CreateEventSubscriptionOutput");
const EventSubscriptionQuotaExceededFault_1 = require("../shapes/EventSubscriptionQuotaExceededFault");
const SubscriptionAlreadyExistFault_1 = require("../shapes/SubscriptionAlreadyExistFault");
const SNSInvalidTopicFault_1 = require("../shapes/SNSInvalidTopicFault");
const SNSNoAuthorizationFault_1 = require("../shapes/SNSNoAuthorizationFault");
const SNSTopicArnNotFoundFault_1 = require("../shapes/SNSTopicArnNotFoundFault");
const SubscriptionCategoryNotFoundFault_1 = require("../shapes/SubscriptionCategoryNotFoundFault");
const SourceNotFoundFault_1 = require("../shapes/SourceNotFoundFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateEventSubscription = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateEventSubscription",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateEventSubscriptionInput_1.CreateEventSubscriptionInput
    },
    output: {
        shape: CreateEventSubscriptionOutput_1.CreateEventSubscriptionOutput,
        resultWrapper: "CreateEventSubscriptionResult"
    },
    errors: [
        {
            shape: EventSubscriptionQuotaExceededFault_1.EventSubscriptionQuotaExceededFault
        },
        {
            shape: SubscriptionAlreadyExistFault_1.SubscriptionAlreadyExistFault
        },
        {
            shape: SNSInvalidTopicFault_1.SNSInvalidTopicFault
        },
        {
            shape: SNSNoAuthorizationFault_1.SNSNoAuthorizationFault
        },
        {
            shape: SNSTopicArnNotFoundFault_1.SNSTopicArnNotFoundFault
        },
        {
            shape: SubscriptionCategoryNotFoundFault_1.SubscriptionCategoryNotFoundFault
        },
        {
            shape: SourceNotFoundFault_1.SourceNotFoundFault
        }
    ]
};
//# sourceMappingURL=CreateEventSubscription.js.map