"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DeleteDBInstanceInput_1 = require("../shapes/DeleteDBInstanceInput");
const DeleteDBInstanceOutput_1 = require("../shapes/DeleteDBInstanceOutput");
const DBInstanceNotFoundFault_1 = require("../shapes/DBInstanceNotFoundFault");
const InvalidDBInstanceStateFault_1 = require("../shapes/InvalidDBInstanceStateFault");
const DBSnapshotAlreadyExistsFault_1 = require("../shapes/DBSnapshotAlreadyExistsFault");
const SnapshotQuotaExceededFault_1 = require("../shapes/SnapshotQuotaExceededFault");
const InvalidDBClusterStateFault_1 = require("../shapes/InvalidDBClusterStateFault");
const DBInstanceAutomatedBackupQuotaExceededFault_1 = require("../shapes/DBInstanceAutomatedBackupQuotaExceededFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.DeleteDBInstance = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "DeleteDBInstance",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: DeleteDBInstanceInput_1.DeleteDBInstanceInput
    },
    output: {
        shape: DeleteDBInstanceOutput_1.DeleteDBInstanceOutput,
        resultWrapper: "DeleteDBInstanceResult"
    },
    errors: [
        {
            shape: DBInstanceNotFoundFault_1.DBInstanceNotFoundFault
        },
        {
            shape: InvalidDBInstanceStateFault_1.InvalidDBInstanceStateFault
        },
        {
            shape: DBSnapshotAlreadyExistsFault_1.DBSnapshotAlreadyExistsFault
        },
        {
            shape: SnapshotQuotaExceededFault_1.SnapshotQuotaExceededFault
        },
        {
            shape: InvalidDBClusterStateFault_1.InvalidDBClusterStateFault
        },
        {
            shape: DBInstanceAutomatedBackupQuotaExceededFault_1.DBInstanceAutomatedBackupQuotaExceededFault
        }
    ]
};
//# sourceMappingURL=DeleteDBInstance.js.map