"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RemoveFromGlobalClusterInput_1 = require("../shapes/RemoveFromGlobalClusterInput");
const RemoveFromGlobalClusterOutput_1 = require("../shapes/RemoveFromGlobalClusterOutput");
const GlobalClusterNotFoundFault_1 = require("../shapes/GlobalClusterNotFoundFault");
const InvalidGlobalClusterStateFault_1 = require("../shapes/InvalidGlobalClusterStateFault");
const DBClusterNotFoundFault_1 = require("../shapes/DBClusterNotFoundFault");
const ServiceMetadata_1 = require("../ServiceMetadata");
exports.RemoveFromGlobalCluster = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "RemoveFromGlobalCluster",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: RemoveFromGlobalClusterInput_1.RemoveFromGlobalClusterInput
    },
    output: {
        shape: RemoveFromGlobalClusterOutput_1.RemoveFromGlobalClusterOutput,
        resultWrapper: "RemoveFromGlobalClusterResult"
    },
    errors: [
        {
            shape: GlobalClusterNotFoundFault_1.GlobalClusterNotFoundFault
        },
        {
            shape: InvalidGlobalClusterStateFault_1.InvalidGlobalClusterStateFault
        },
        {
            shape: DBClusterNotFoundFault_1.DBClusterNotFoundFault
        }
    ]
};
//# sourceMappingURL=RemoveFromGlobalCluster.js.map