/**
 * <p>Contains the available processor feature information for the DB instance class of a DB instance.</p> <p>For more information, see <a href="https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Concepts.DBInstanceClass.html#USER_ConfigureProcessor">Configuring the Processor of the DB Instance Class</a> in the <i>Amazon RDS User Guide. </i> </p>
 */
export interface _AvailableProcessorFeature {
    /**
     * <p>The name of the processor feature. Valid names are <code>coreCount</code> and <code>threadsPerCore</code>.</p>
     */
    Name?: string;
    /**
     * <p>The default value for the processor feature of the DB instance class.</p>
     */
    DefaultValue?: string;
    /**
     * <p>The allowed values for the processor feature of the DB instance class.</p>
     */
    AllowedValues?: string;
}
export declare type _UnmarshalledAvailableProcessorFeature = _AvailableProcessorFeature;
