/**
 * <p>Contains the details of an Amazon RDS DB parameter group. </p> <p>This data type is used as a response element in the <code>DescribeDBParameterGroups</code> action. </p>
 */
export interface _DBParameterGroup {
    /**
     * <p>Provides the name of the DB parameter group.</p>
     */
    DBParameterGroupName?: string;
    /**
     * <p>Provides the name of the DB parameter group family that this DB parameter group is compatible with.</p>
     */
    DBParameterGroupFamily?: string;
    /**
     * <p>Provides the customer-specified description for this DB parameter group.</p>
     */
    Description?: string;
    /**
     * <p>The Amazon Resource Name (ARN) for the DB parameter group.</p>
     */
    DBParameterGroupArn?: string;
}
export declare type _UnmarshalledDBParameterGroup = _DBParameterGroup;
