import { _Option, _UnmarshalledOption } from "./_Option";
/**
 * <p/>
 */
export interface _OptionGroup {
    /**
     * <p>Specifies the name of the option group.</p>
     */
    OptionGroupName?: string;
    /**
     * <p>Provides a description of the option group.</p>
     */
    OptionGroupDescription?: string;
    /**
     * <p>Indicates the name of the engine that this option group can be applied to.</p>
     */
    EngineName?: string;
    /**
     * <p>Indicates the major engine version associated with this option group.</p>
     */
    MajorEngineVersion?: string;
    /**
     * <p>Indicates what options are available in the option group.</p>
     */
    Options?: Array<_Option> | Iterable<_Option>;
    /**
     * <p>Indicates whether this option group can be applied to both VPC and non-VPC instances. The value <code>true</code> indicates the option group can be applied to both VPC and non-VPC instances. </p>
     */
    AllowsVpcAndNonVpcInstanceMemberships?: boolean;
    /**
     * <p>If <b>AllowsVpcAndNonVpcInstanceMemberships</b> is <code>false</code>, this field is blank. If <b>AllowsVpcAndNonVpcInstanceMemberships</b> is <code>true</code> and this field is blank, then this option group can be applied to both VPC and non-VPC instances. If this field contains a value, then this option group can only be applied to instances that are in the VPC indicated by this field. </p>
     */
    VpcId?: string;
    /**
     * <p>The Amazon Resource Name (ARN) for the option group.</p>
     */
    OptionGroupArn?: string;
}
export interface _UnmarshalledOptionGroup extends _OptionGroup {
    /**
     * <p>Indicates what options are available in the option group.</p>
     */
    Options?: Array<_UnmarshalledOption>;
}
